//

#define Battry_CELL 6   //12V

#define NSHENT  read_adc10bit(7)
#define VSHENT  NSHENT*0.004883
#define ISHENT  NSHENT*0.028722

#define NBUT    read_adc10bit(6)
#define VBUT    NBUT*0.004883

#define NNBUT   (NBUT-NSHENT)
#define VVBUT   NNBUT*0.024414

#define ADC_VREF_TYPE_10 0x00
// Read the AD conversion result
unsigned int read_adc10bit(unsigned char adc_input)
{
ADMUX=ADC_VREF_TYPE_10 & 0xff; //SET BIT RATE
ADMUX=adc_input | (ADC_VREF_TYPE_10 & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


#define Float   PORTB.0
#define Fast    PORTB.1
#define Shutdown    PORTB.2
#define Limit   PORTB.3

 float VBATTRY;
float get_status(void){

 float stat;
 
 Shutdown=1;
 VBATTRY=VVBUT;
 stat = (VBATTRY-11.9)/0.75*100; 
 if (stat<0) stat=10;
 if(PINE.5==1)
    Shutdown=0;
 return stat;
}

void set_charge_type(){
float s;

    s=get_status();
    if(PINE.5==0)
    return;
if(s>=95){
    if(Float!=1)
    Float=1;Fast=0;
 }else{
    if(Fast!=1)
   Fast=1;Float=0;
 } 
} 

char tukometr=0;

// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
if(tukometr++>=1){
tukometr=0;
set_charge_type();
}
}